#line 1 "C:/Evil Genius/MikroC/P16F688/Hero IR Remote/Hero_IR_Remote.c"
#line 1 "c:/evil genius/mikroc/p16f688/hero ir remote/slcd.h"
#line 14 "c:/evil genius/mikroc/p16f688/hero ir remote/slcd.h"
void Delay5us()
{
Delay_us(5);
}

void Delay20us()
{
Delay_us(20);
}

void Delay10ms()
{
Delay_ms(10);
}

void Delay100ms()
{
Delay_ms(100);
}



const sLCD_FIRST_ROW = 128;
const sLCD_SECOND_ROW = 192;
const sLCD_THIRD_ROW = 148;
const sLCD_FOURTH_ROW = 212;
const sLCD_CLEAR = 1;
const sLCD_RETURN_HOME = 2;
const sLCD_CURSOR_OFF = 12;
const sLCD_UNDERLINE_ON = 14;
const sLCD_BLINK_CURSOR_ON = 15;
const sLCD_MOVE_CURSOR_LEFT = 16;
const sLCD_MOVE_CURSOR_RIGHT = 20;
const sLCD_TURN_OFF = 0;
const sLCD_TURN_ON = 8;
const sLCD_SHIFT_LEFT = 24;
const sLCD_SHIFT_RIGHT = 28;


void Nybble(unsigned char LCDOut, unsigned char RS)

{
unsigned char i;
  PORTA.F5  = 0;
 for (i = 0; i < 6; i++)
 {
  PORTA.F4  = 1;
 Delay5us();
  PORTA.F4  = 0;
 }
 LCDOut = LCDOut | (1 << 5) | ((RS & 1) * (1 << 4));
 for (i = 0; i < 6; i++)
 {
 if (0 != (LCDOut & (1 << 5)))
  PORTA.F5  = 1;
 else
  PORTA.F5  = 0;
 LCDOut = LCDOut << 1;
  PORTA.F4  = 1;
 Delay5us();
  PORTA.F4  = 0;
 }
  PORTA.F5  = 1;
  PORTA.F5  = 1;
  PORTA.F5  = 0;
  PORTA.F5  = 0;

}


void sLCDWrite(unsigned char LCDData, unsigned char RSValue)

{
 Nybble((LCDData >> 4) & 0x0F, RSValue);
 Nybble(LCDData & 0x0F, RSValue);
 if ((0 == (LCDData & 0xFC)) && (0 == RSValue))
 Delay20us();
 else
 Delay20us();

}


void sLCD_Chr(unsigned char row, unsigned char col, unsigned char character)

{
 sLCDWrite((row + (col - 1)), 0);
 sLCDWrite(character, 1);
}


void sLCD_Chr_Cp(unsigned char character)

{
 sLCDWrite(character, 1);
}


void sLCD_Cmd(unsigned char instruction)

{
 sLCDWrite (instruction, 0);
}


void sMove_Cursor(unsigned char row, unsigned char col)

{
 sLCDWrite((row + (col - 1)), 0);
}


int NumtoChar(unsigned char val)
{
 unsigned char ch;
 if (val < 10)
 {
 ch=val+'0';
 }
 else
 {
 val=val-10;
 ch=val + 'A';
 }
 return(ch);

}


void sResetLCD()

{
 sLCDWrite(0b00000001, 0);
 Delay10ms();
 sLCDWrite(0b00000110, 0);
 Delay10ms();
 sLCDWrite(0b00001100, 0);
 Delay10ms();

}


void sDString(const char s[],unsigned char row)



{
 int i;
 sLCDWrite(row, 0);
 for (i = 0; s[i] != 0; i++)
 {
 sLCDWrite(s[i], 1);
 }

}


void sLCDtoBCD(long int val, unsigned char digits)

{
 int d;
 unsigned char ch;

 if (digits == 5)
 {
 d = val/10000;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 3)
 {
 val = val%10000;
 d = val/1000;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 2)
 {
 val = val%1000;
 d = val/100;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 1)
 {
 val = val%100;
 d = val/10;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits == 1)
 {
 val = val%100;
 }
 d = val % 10;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);

}
#line 1 "c:/evil genius/mikroc/p16f688/hero ir remote/sonyir.h"




void sony_rx_tick(void)
{
 Delay_us(287);
}


sony_rx_run(unsigned char sonyir)
{
 unsigned char sony_rx_cmd, sony_rx_addr;
 unsigned char i;
 long b;
 b = 0;
 sony_rx_cmd = 0;
 sony_rx_addr = 0;

do {
 if (b == 10000)
 {
 sonyir = 0;
 PORTC = 0;
 PORTA.F1 = 0;
 return sonyir;
 }
 b++;
} while ( PORTA.F0  == 1);

while( PORTA.F0  == 1);

 for(i = 0; i < 7; i ++)
 {
 sony_rx_tick();
 if( PORTA.F0  != 0) return;
 }

 while( PORTA.F0  == 0);
 sony_rx_tick();
 for(i = 0; i < 7; i ++)
 {
 if( PORTA.F0  != 1) return;
 sony_rx_tick();
 sony_rx_tick();
 if( PORTA.F0  != 0) return;
 sony_rx_tick();
 sony_rx_tick();
 if( PORTA.F0  == 0)
 {
 sony_rx_cmd |= 0x80;
 sony_rx_tick();
 sony_rx_tick();
 }
 sony_rx_cmd = sony_rx_cmd >> 1;
 }
 sony_rx_cmd = sony_rx_cmd & 0x7f;

 for(i = 0; i < 5; i ++)
 {
 if( PORTA.F0  != 1) return;
 sony_rx_tick();
 sony_rx_tick();
 if( PORTA.F0  != 0) return;
 sony_rx_tick();
 sony_rx_tick();
 if( PORTA.F0  == 0)
 {
 sony_rx_addr |= 0x80;
 sony_rx_tick();
 sony_rx_tick();
 }
 sony_rx_addr = sony_rx_addr >> 1;
 }
 sony_rx_addr = sony_rx_addr >> 2;
 sony_rx_addr = sony_rx_addr & 0x1f;
 sonyir = sony_rx_cmd;
 return sonyir;
}
#line 1 "c:/evil genius/mikroc/p16f688/hero ir remote/binary.h"

char output[10] = "%11111111";
char str[10];
char outputl[18] = "%1111111111111111";
char strl[18];

void Byte2Binary(char row, char col, unsigned char byte_in, char *output)
{
unsigned char pos, k;
char output[10] = "%11111111";
 pos = 1;
 if (row == 1)
 row = 128;
 if (row == 2)
 row = 192;
 if (row == 3)
 row = 148;
 if (row == 4)
 row = 212;
 while (pos < 9)
 {
 if ((byte_in & 0x80) == 0)
 {
 output[pos] = 48;
 }
 byte_in = byte_in << 1;
 ++pos;
 }
 sLCD_Cmd(row + (col - 1));
 for (k = 0; k < 9; k++)
 {
 sLCD_Chr_Cp(output[k]);
 }
}

void Word2Binary(char row, char col, unsigned int word_in, int *outputl)
{
unsigned char pos, k;
char outputl[18] = "%1111111111111111";
 pos = 1;
 if (row == 1)
 row = 128;
 if (row == 2)
 row = 192;
 if (row == 3)
 row = 148;
 if (row == 4)
 row = 212;
 while (pos < 17)
 {
 if ((word_in & 0x8000) == 0)
 {
 outputl[pos] = 48;
 }
 word_in = word_in << 1;
 ++pos;
 }
 sLCD_Cmd(row + (col - 1));
 for (k = 0; k < 17; k++)
 {
 sLCD_Chr_Cp(outputl[k]);
 }
}
#line 77 "C:/Evil Genius/MikroC/P16F688/Hero IR Remote/Hero_IR_Remote.c"
const char Message1[17] = "HERO 1 IR Demo  ";
const char Message2[17] = "P16F688         ";
const char Message3[17] = "Motor Forward   ";
const char Message4[17] = "Motor Left      ";
const char Message5[17] = "Motor Right     ";
const char Message6[17] = "Head Right      ";
const char Message7[17] = "Head Left       ";
const char Message8[17] = "Arm Raise       ";
const char Message9[17] = "Arm Lower       ";
const char Message10[17] = "Arm Extend      ";
const char Message11[17] = "Arm Retract     ";
const char Message12[17] = "Grip Open       ";
const char Message13[17] = "Grip Close      ";
const char Message14[17] = "Wrist Pivot L   ";
const char Message15[17] = "Wrist Pivot R   ";
const char Message16[17] = "Wrist Rotate L  ";
const char Message17[17] = "Wrist Rotate R  ";
const char Message18[17] = "Motor Reverse   ";
const char Message19[17] = "IR Code         ";
const char Message20[17] = "                ";
const char Message21[17] = "Stop            ";
const char Message22[17] = "Head Mode       ";
char Dlay = 0;
char Temp = 0;
char Cycles = 0;
char IRCode = 0;
unsigned char sony_cmd;
unsigned short *port;

void Delay500ms()
{
Delay_ms(500);
}

void Delay1000ms()
{
Delay_ms(1000);
}

void main()
{
long int num;
unsigned char i, j, k, n, head, headfunc, previous, code, z;

const delay = 1000;

 ANSEL = 0b00000000;
 PORTA = 0b00000000;
 PORTC = 0b00000000;
 CMCON0 = 0b00000111;
 OSCCON = 0b01110001;
 TRISA = 0b00000001;
 TRISC = 0b00000000;

 num = 1;
 head = 0;



 for (i = 0; i < 3; i++)
 {
 Delay10ms();
 Nybble(3, 0);
 }
 Nybble(2, 0);
 Delay10ms();
 sResetLCD();
 Delay500ms();
 sDString(Message1, sLCD_FIRST_ROW);
 sDString(Message2, sLCD_SECOND_ROW);
 Delay1000ms();
 Delay1000ms();
 sLCD_Cmd(sLCD_CURSOR_OFF);
 sResetLCD();

while (1==1)
 {
 Byte2Binary(sLCD_THIRD_ROW, 1, PORTC, output);
 sDString(Message19, sLCD_FIRST_ROW);
 sLCD_Cmd(sLCD_SECOND_ROW);
 sony_cmd = sony_rx_run(code);


 if (sony_cmd == 21)
 {
 head = head ^ 1;
 Delay_ms(500);
 }
 if (head == 1)
 {
 headfunc = 0b100000;
 n = sony_cmd + 10;
 }
 else
 {
 headfunc = 0b000000;
 n = sony_cmd;
 }
 sMove_Cursor(sLCD_SECOND_ROW, 1);
 sLCDtoBCD(n, 3);


 sDString(Message20, sLCD_FOURTH_ROW);
switch(n)
 {

 case 121:

 PORTC = 0b001111;

 PORTA.F1 = 1;
 sDString(Message3, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 124:

 PORTC = 0b001101;

 PORTA.F1 = 1;
 sDString(Message5, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 123:

 PORTC = 0b001110;

 PORTA.F1 = 1;
 sDString(Message4, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 122:

 PORTC = 0b011111;

 PORTA.F1 = 1;
 sDString(Message18, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 11:

 PORTC = 0b000000;

 PORTA.F1 = 0;
 sDString(Message21, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 21:

 PORTC = 0b000000;

 PORTA.F1 = 0;
 sDString(Message21, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 133:

 PORTC = 0b011110 + headfunc;

 PORTA.F1 = 1;
 sDString(Message7, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 134:

 PORTC = 0b011101 + headfunc;

 PORTA.F1 = 1;
 sDString(Message6, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 131:

 PORTC = 0b010101 + headfunc;

 PORTA.F1 = 1;
 sDString(Message8, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 132:

 PORTC = 0b010110 + headfunc;

 PORTA.F1 = 1;
 sDString(Message9, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 59:

 PORTC = 0b011001 + headfunc;

 PORTA.F1 = 1;
 sDString(Message10, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 58:

 PORTC = 0b011010 + headfunc;

 PORTA.F1 = 1;
 sDString(Message11, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 13:

 PORTC = 0b001110 + headfunc;

 PORTA.F1 = 1;
 sDString(Message12, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 15:

 PORTC = 0b001101 + headfunc;

 PORTA.F1 = 1;
 sDString(Message13, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 14:

 PORTC = 0b000110 + headfunc;

 PORTA.F1 = 1;
 sDString(Message14, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 12:

 PORTC = 0b000101 + headfunc;

 PORTA.F1 = 1;
 sDString(Message15, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 16:

 PORTC = 0b001010 + headfunc;

 PORTA.F1 = 1;
 sDString(Message16, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 case 18:

 PORTC = 0b001001 + headfunc;

 PORTA.F1 = 1;
 sDString(Message17, sLCD_FOURTH_ROW);
 Delay500ms();

 break;

 default:


 z = 0;

 }
 }
}
