//***************************************************************************
//  sLCD_Consts.h
//  Cursor Move Commands for sLCD
const sLCD_FIRST_ROW         = 128;
const sLCD_SECOND_ROW        = 192;
const sLCD_THIRD_ROW         = 148;
const sLCD_FOURTH_ROW        = 212;
const sLCD_CLEAR             =   1;
const sLCD_RETURN_HOME       =   2;
const sLCD_CURSOR_OFF        =  12;
const sLCD_UNDERLINE_ON      =  14;
const sLCD_BLINK_CURSOR_ON   =  15;
const sLCD_MOVE_CURSOR_LEFT  =  16;
const sLCD_MOVE_CURSOR_RIGHT =  20;
const sLCD_TURN_OFF          =   0;
const sLCD_TURN_ON           =   8;
const sLCD_SHIFT_LEFT        =  24;
const sLCD_SHIFT_RIGHT       =  28;
//***************************************************************************